package com.hfkj.dao;

import com.hfkj.entity.EnItemSegments;
import com.hfkj.entity.EnItemSegmentsExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface EnItemSegmentsMapper extends EnItemSegmentsMapperExt {
    @SelectProvider(type=EnItemSegmentsSqlProvider.class, method="countByExample")
    long countByExample(EnItemSegmentsExample example);

    @DeleteProvider(type=EnItemSegmentsSqlProvider.class, method="deleteByExample")
    int deleteByExample(EnItemSegmentsExample example);

    @Delete({
        "delete from en_item_segments",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into en_item_segments (item_id, oil_depot_id, ",
        "segment_name, address, ",
        "person, contact_info, ",
        "latitude, longitude, ",
        "`status`, create_user, ",
        "create_user_name, create_time, ",
        "update_user, update_user_name, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{itemId,jdbcType=BIGINT}, #{oilDepotId,jdbcType=BIGINT}, ",
        "#{segmentName,jdbcType=VARCHAR}, #{address,jdbcType=VARCHAR}, ",
        "#{person,jdbcType=VARCHAR}, #{contactInfo,jdbcType=VARCHAR}, ",
        "#{latitude,jdbcType=DECIMAL}, #{longitude,jdbcType=DECIMAL}, ",
        "#{status,jdbcType=INTEGER}, #{createUser,jdbcType=BIGINT}, ",
        "#{createUserName,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateUser,jdbcType=BIGINT}, #{updateUserName,jdbcType=VARCHAR}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(EnItemSegments record);

    @InsertProvider(type=EnItemSegmentsSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(EnItemSegments record);

    @SelectProvider(type=EnItemSegmentsSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="item_id", property="itemId", jdbcType=JdbcType.BIGINT),
        @Result(column="oil_depot_id", property="oilDepotId", jdbcType=JdbcType.BIGINT),
        @Result(column="segment_name", property="segmentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="address", property="address", jdbcType=JdbcType.VARCHAR),
        @Result(column="person", property="person", jdbcType=JdbcType.VARCHAR),
        @Result(column="contact_info", property="contactInfo", jdbcType=JdbcType.VARCHAR),
        @Result(column="latitude", property="latitude", jdbcType=JdbcType.DECIMAL),
        @Result(column="longitude", property="longitude", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_user", property="createUser", jdbcType=JdbcType.BIGINT),
        @Result(column="create_user_name", property="createUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_user", property="updateUser", jdbcType=JdbcType.BIGINT),
        @Result(column="update_user_name", property="updateUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<EnItemSegments> selectByExample(EnItemSegmentsExample example);

    @Select({
        "select",
        "id, item_id, oil_depot_id, segment_name, address, person, contact_info, latitude, ",
        "longitude, `status`, create_user, create_user_name, create_time, update_user, ",
        "update_user_name, update_time, ext_1, ext_2, ext_3",
        "from en_item_segments",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="item_id", property="itemId", jdbcType=JdbcType.BIGINT),
        @Result(column="oil_depot_id", property="oilDepotId", jdbcType=JdbcType.BIGINT),
        @Result(column="segment_name", property="segmentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="address", property="address", jdbcType=JdbcType.VARCHAR),
        @Result(column="person", property="person", jdbcType=JdbcType.VARCHAR),
        @Result(column="contact_info", property="contactInfo", jdbcType=JdbcType.VARCHAR),
        @Result(column="latitude", property="latitude", jdbcType=JdbcType.DECIMAL),
        @Result(column="longitude", property="longitude", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_user", property="createUser", jdbcType=JdbcType.BIGINT),
        @Result(column="create_user_name", property="createUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_user", property="updateUser", jdbcType=JdbcType.BIGINT),
        @Result(column="update_user_name", property="updateUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    EnItemSegments selectByPrimaryKey(Long id);

    @UpdateProvider(type=EnItemSegmentsSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") EnItemSegments record, @Param("example") EnItemSegmentsExample example);

    @UpdateProvider(type=EnItemSegmentsSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") EnItemSegments record, @Param("example") EnItemSegmentsExample example);

    @UpdateProvider(type=EnItemSegmentsSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(EnItemSegments record);

    @Update({
        "update en_item_segments",
        "set item_id = #{itemId,jdbcType=BIGINT},",
          "oil_depot_id = #{oilDepotId,jdbcType=BIGINT},",
          "segment_name = #{segmentName,jdbcType=VARCHAR},",
          "address = #{address,jdbcType=VARCHAR},",
          "person = #{person,jdbcType=VARCHAR},",
          "contact_info = #{contactInfo,jdbcType=VARCHAR},",
          "latitude = #{latitude,jdbcType=DECIMAL},",
          "longitude = #{longitude,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_user = #{createUser,jdbcType=BIGINT},",
          "create_user_name = #{createUserName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_user = #{updateUser,jdbcType=BIGINT},",
          "update_user_name = #{updateUserName,jdbcType=VARCHAR},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(EnItemSegments record);
}